/*
  The partysip program is a modular SIP proxy server (SIP -rfc2543-)
  Copyright (C) 2002  WellX Telecom   - <partysip@wellx.com>
  Copyright (C) 2002  Aymeric MOIZARD - <jack@atosc.org>
  
  Partysip is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Partysip is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with Foobar; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#ifndef _OSIP_CTX_H_
#define _OSIP_CTX_H_

#include <osip/osip.h>
#include <osip/thread.h>

#ifdef OSIP_MT

typedef struct _osip_ctx_t
{
  transaction_t *transaction;
  sthread_t *thread;
}
osip_ctx_t;

int osip_ctx_init (osip_ctx_t ** osip_ctx, transaction_t * transaction);
int osip_ctx_start (osip_ctx_t * osip_ctx);
void osip_ctx_stop (osip_ctx_t * osip_ctx);

#elif
#error Compile multysip and oSIP with -DOSIP_MT (or use ./configure --enable-mt)
#endif


#endif
