/*
  The ls_localdb plugin is a GPL plugin for partysip.
  Copyright (C) 2002  WellX Telecom   - <partysip@wellx.com>
  Copyright (C) 2002  Aymeric MOIZARD - <jack@atosc.org>
  
  The ls_localdb plugin is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  The ls_localdb plugin is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <partysip/partysip.h>

#include "ls_localdb.h"

/* this structure is retreived by the core application
   with dlsym */
psp_plugin_t PSP_PLUGIN_DECLARE_DATA ls_localdb_plugin;

/* element shared with the core application layer */
/* all xxx_plugin elements MUST be DYNAMICLY ALLOCATED
   as the core application will assume they are */
imp_plugin_t *localdb_plug;

extern ls_localdb_ctx_t *ls_localdb_context;

/* this is called by the core application when the module
   is loaded (the address of this method is located in
   the structure ls_localdb_plugin->plugin_init() */
PSP_PLUGIN_DECLARE (int)
plugin_init ()
{
  imp_func_t *fn;
  int i;

  OSIP_TRACE (osip_trace (__FILE__, __LINE__, OSIP_INFO2, NULL,
                          "ls_localdb plugin: plugin_init()!\n"));

  i = ls_localdb_ctx_init ();
  if (i != 0)
    goto pi_error1;

  psp_plugin_take_ownership (&ls_localdb_plugin);
  i = psp_core_load_imp_plugin (&localdb_plug, &ls_localdb_plugin);
  if (i != 0)
    goto pi_error2;

  /*  This may be usefull in the future?
     imp_plugin_set_input_socket(localdb_plug, rs_ctx->in_socket); */

  /* INIT HOOK METHOD */
  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_invite_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_ack_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_register_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_bye_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_options_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_info_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_cancel_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_notify_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_subscribe_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  i = imp_func_init (&fn, &cb_ls_localdb_search_user_location,
                     ls_localdb_plugin.plug_id);
  if (i != 0)
    goto pi_error3;
  i = psp_core_add_imp_unknown_hook (fn, PSP_HOOK_LAST);
  if (i != 0)
    goto pi_error3;

  return 0;


  /* TODO */
pi_error3:
pi_error2:
  ls_localdb_ctx_free ();
pi_error1:
  return -1;
}

PSP_PLUGIN_DECLARE (int)
plugin_start ()
{
  /*  OSIP_TRACE(osip_trace(__FILE__,__LINE__,OSIP_INFO2,NULL,
     "ls_localdb plugin: plugin_start()!\n"));
   */
  return -1;
}

PSP_PLUGIN_DECLARE (int)
plugin_release ()
{
  OSIP_TRACE (osip_trace (__FILE__, __LINE__, OSIP_INFO2, NULL,
                          "ls_localdb plugin: plugin_release()!\n"));
  ls_localdb_ctx_free ();
  ls_localdb_context = NULL;
  return -1;
}

psp_plugin_t PSP_PLUGIN_DECLARE_DATA ls_localdb_plugin = {
  0,                            /* uninitialized */
  "Location search plugin",
  "0.4.5",
  "plugin for location search in local cache.",
  PLUGIN_IMP,
  0,                            /* number of owners is always 0 at the begining */
  NULL,                         /* future place for the dso_handle */
  &plugin_init,
  &plugin_start,
  &plugin_release
};
