/*
  The partysip program is a modular SIP proxy server (SIP -rfc2543-)
  Copyright (C) 2002  WellX Telecom   - <partysip@wellx.com>
  Copyright (C) 2002  Aymeric MOIZARD - <jack@atosc.org>
  
  Partysip is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  Partysip is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with Foobar; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <psp_req.h>

int
slp_branch_init (slp_branch_t ** sl, char *branch)
{
  *sl = (slp_branch_t *) smalloc (sizeof (slp_branch_t));
  if (*sl == NULL)
    return -1;
  (*sl)->branch = branch;
  (*sl)->ctx_start = time (NULL);
  (*sl)->ctx_timeout = 32;
  (*sl)->url = NULL;
  (*sl)->request = NULL;
  (*sl)->response = NULL;
  return 0;
}

void
slp_branch_free (slp_branch_t * sl)
{
  if (sl == NULL)
    return;
  sfree (sl->branch);
  url_free (sl->url);
  sfree (sl->url);
  msg_free (sl->request);
  sfree (sl->request);
  msg_free (sl->response);
  sfree (sl->response);
}

int
slp_branch_set_url (slp_branch_t * sl, url_t * url)
{
  if (sl == NULL)
    return -1;
  sl->url = url;
  return 0;
}

int
slp_branch_set_request (slp_branch_t * sl, sip_t * request)
{
  if (sl == NULL)
    return -1;
  sl->request = request;
  return 0;
}

int
slp_branch_set_response (slp_branch_t * sl, sip_t * response)
{
  if (sl == NULL)
    return -1;
  sl->response = response;
  return 0;
}

int
slp_branch_set_timeout (slp_branch_t * sl, int timeout)
{
  if (sl == NULL)
    return -1;
  sl->ctx_timeout = timeout;
  return 0;
}

int
slp_branch_match (slp_branch_t * sl, char *branch)
{
  if (sl == NULL)
    return -1;
  if (0 == strcmp (sl->branch, branch))
    return 0;
  return -1;
}
